/* NOTE - eventually this file will be automatically updated using a Perl script that understand
 * the naming of test case files, functions, and namespaces.
 */

#include <time.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "std_testcase.h"
#include "testcases.h"

#include <signal.h>

#define ALERT_TIMEOUT   3

pid_t childproc;
int returnCode          = 0;
int totalBadTests       = 0;
int passedBadTests      = 0;
int failedBadTests      = 0;
int timedOutBadTests    = 0;

int totalGoodTests      = 0;
int passedGoodTests     = 0;
int failedGoodTests     = 0;
int timedOutGoodTests   = 0;

void infinite_handler(int signo) {
    exit(SIGUSR1);
}

int main(int argc, char * argv[]) {
    
        signal(SIGALRM, infinite_handler);

        /* seed randomness */
        srand( (unsigned)time(NULL) );
        
        globalArgc = argc;
        globalArgv = argv;
        
#ifndef OMITGOOD
        
        /* Calling C good functions */
        /* BEGIN-AUTOGENERATED-C-GOOD-FUNCTION-CALLS */

        /* END-AUTOGENERATED-C-GOOD-FUNCTION-CALLS */
#ifdef __cplusplus
        /* Calling C++ good functions */
        /* BEGIN-AUTOGENERATED-CPP-GOOD-FUNCTION-CALLS */

        /* END-AUTOGENERATED-CPP-GOOD-FUNCTION-CALLS */
        
#endif /* __cplusplus */
        
#endif /* OMITGOOD */

#ifndef OMITBAD
        /* Calling C bad functions */
        /* BEGIN-AUTOGENERATED-C-BAD-FUNCTION-CALLS */

        /* END-AUTOGENERATED-C-BAD-FUNCTION-CALLS */
#ifdef __cplusplus
        /* Calling C++ bad functions */
        /* BEGIN-AUTOGENERATED-CPP-BAD-FUNCTION-CALLS */

        /* END-AUTOGENERATED-CPP-BAD-FUNCTION-CALLS */
        
#endif /* __cplusplus */
        
#endif /* OMITBAD */

    printf("Total Bad Tests: %d\nPassed: %d\nFailed: %d\n", totalBadTests, passedBadTests, failedBadTests);
    printf("Total Good Tests: %d\nPassed: %d\nFailed: %d\n", totalGoodTests, passedGoodTests, failedGoodTests);
    printf("Total Bad Time Outs: %d\nTotal Good Time Outs: %d\n", timedOutBadTests, timedOutGoodTests);
    return 0;
        
} 
